package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.text.DecimalFormat;

/**
 * @Description : 关系-用户角色
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.417
 * @Modify      :
 **/
@Data
@Entity
@Table(name="REF_USER_ROLE")
@DynamicInsert
@DynamicUpdate
@Api(value="关系-用户角色",description = "关系-用户角色")
public class RefUserRole extends BaseBean {

    private static final long serialVersionUID = 1L;


    @Column(name="USER_ID")
    @ApiParam(value ="用户ID" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long userId;

    public Long getUserId() {
        if(userId != null) {
            return userId.longValue();
        }else{
            return userId;
        }
    }
    @Column(name="ROLE_ID")
    @ApiParam(value ="角色ID" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long roleId;

    public Long getRoleId() {
        if(roleId != null) {
            return roleId.longValue();
        }else{
            return roleId;
        }
    }
 
    @Column(name="RED_ROLE_NAME")
    @ApiParam(value ="角色名称")
    private String redRoleName;

    public RefUserRole() {
    }

    public RefUserRole(Long userId, Long roleId, String redRoleName) {
        this.userId = userId;
        this.roleId = roleId;
        this.redRoleName = redRoleName;
    }
}
