package cn.estsh.i3plus.pojo.wms.sqlpack;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.wms.bean.*;
import cn.estsh.i3plus.pojo.wms.bean.WareHouse;
import cn.estsh.i3plus.pojo.wms.bean.WmsTrans;
import cn.estsh.i3plus.pojo.wms.bean.WmsTransType;

/**
 * @Description : 仓库管理对象封装
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-10-31 10:45
 * @Modify:
 **/
public class WmsHqlPack {

    /**
     * 库位物料信息 分页查询
     * @param wmsLocatePart
     * @return
     */
    public static String packHqlWmsLocatePart(WmsLocatePart wmsLocatePart) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocatePart.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartName(), "partName", result);

        return result.toString();
    }

    /**
     * 库位信息 分页查询
     * @param wmsLocate
     * @return
     */
    public static String packHqlWmsLocates(WmsLocate wmsLocate) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocate.getLocateNo(),"locateNo",result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateName(),"locateName",result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateType(),"locateType",result);
        HqlPack.getStringLikerPack(wmsLocate.getWhNo(),"whNo",result);
        HqlPack.getStringLikerPack(wmsLocate.getZoneNo(),"zoneNo",result);

        return result.toString();
    }

    /**
     * 工厂仓库模糊分页查询
     * @param wareHouse
     * @return
     */
    public static String packHqlFactoryStore(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(wareHouse.getCode(),"code", result);
        // 部门代码
        HqlPack.getStringLikerPack(wareHouse.getName(),"name", result);

        return result.toString();
    }

    public static String packHqlWmsButton(WmsButton wmsButton) {
        StringBuffer result = new StringBuffer();

        // 功能名称（name）
        HqlPack.getStringLikerPack(wmsButton.getName(),"name", result);
        // 前端实现（ui）
        HqlPack.getStringLikerPack(wmsButton.getUi(),"ui", result);
        // URI权限规则（bs）
        HqlPack.getStringLikerPack(wmsButton.getBs(),"bs", result);

        return result.toString();
    }

    /**
     * 元数据信息 分页查询
     * @param wmsObject
     * @return
     */
    public static String packHqlWmsObject(WmsObject wmsObject){
        StringBuffer result = new StringBuffer();

        // 编码
        HqlPack.getStringLikerPack(wmsObject.getCode(),"code",result);
       // 名称
        HqlPack.getStringEqualPack(wmsObject.getName(),"name",result);
        // 数据主表
        HqlPack.getStringEqualPack(wmsObject.getTableName(),"tableName",result);
        // 自定义业务拦截
        HqlPack.getStringEqualPack(wmsObject.getBizIntercept(),"bizIntercept",result);

        return result.toString();
    }

    /**
     * 元数据字段分页查询
     * @param wmsField
     * @return
     */
    public static String packHqlWmsField(WmsField wmsField){
        StringBuffer result = new StringBuffer();
        // 编码
        HqlPack.getStringLikerPack(wmsField.getObjectCode(),"objectCode",result);
        HqlPack.getStringLikerPack(wmsField.getTableName(),"tableName",result);
        return result.toString();
    }


    /**
     * 交易类型信息 分页查询
     * @param wmsTransType
     * @return
     */
    public static String packHqlWmsTransType(WmsTransType wmsTransType) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getNumEqualPack(wmsTransType.getIsValid(),"isValid",result);
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeCode(),"transTypeCode",result);
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeName(),"transTypeName",result);

        return result.toString();
    }

    /**
     * 库存交易记录信息 分页查询
     * @param wmsTrans
     * @return
     */
    public static String packHqlWmsTrans(WmsTrans wmsTrans) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringEqualPack(wmsTrans.getTransCode(),"transCode",result);
        HqlPack.getStringEqualPack(wmsTrans.getSn(),"sn",result);
        HqlPack.timeBuilder(wmsTrans.getCreateDatetime(),null,"createDatetime",result,true);

        return result.toString();
    }

    /**
     * 仓库分页查询条件
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouse(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wareHouse.getAddress(), "address", result);
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);
        HqlPack.getStringEqualPack(CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue()+"","isValid",result);
        return result.toString();
    }

    /**
     * 存储区信息 查询条件封装
     * @param wmsZones
     * @return
     */
    public static String packHqlWmsZones(WmsZones wmsZones) {
        StringBuffer result = new StringBuffer();
        //仓库代码
        HqlPack.getStringLikerPack(wmsZones.getWhNo(),"whNo",result);
        //库存地代码
        HqlPack.getStringLikerPack(wmsZones.getAreaNo(),"areaNo",result);
        //存储区代码
        HqlPack.getStringLikerPack(wmsZones.getZoneNo(),"zoneNo",result);
        return result.toString();
    }

    /**
     * 客户信息 查询条件封装
     * @param basCustomer
     * @return
     */
    public static String packHqlBasCustomer(BasCustomer basCustomer){
        StringBuffer result = new StringBuffer();
        //客户编号
        HqlPack.getStringLikerPack(basCustomer.getCustNo(),"custNo",result);
        //客户简称
        HqlPack.getStringLikerPack(basCustomer.getCustName(),"custName",result);
        //客户全称
        HqlPack.getStringLikerPack(basCustomer.getCustDesc(),"custDesc",result);
        return result.toString();
    }

    /**
     * 客户发往地信息 查询条件封装
     * @param wmsShippingFlag
     * @return
     */
    public static String packHqlWmsShippingFlag(WmsShippingFlag wmsShippingFlag){
        StringBuffer result = new StringBuffer();
        //供应商编号
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagNo(),"flagNo",result);
        //供应商简称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagName(),"flagName",result);
       //供应商全称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagDesc(),"flagDesc",result);
        return result.toString();
    }
}
